/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11 by edhill, Mon Sep 29 16:15:23 2003 UTC revision 1.11.2.10 by edhill, Fri Oct 3 19:49:06 2003 UTC
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17        RETVAL=$?
18        if test "x${RETVAL}" = x0 ; then
19            echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20            exit 99
21        fi
22        grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23        RETVAL=$?
24        if test "x${RETVAL}" = x0 ; then
25            echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26            exit 99
27        fi
28        grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29        RETVAL=$?
30        if test "x${RETVAL}" = x0 ; then
31            echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32            exit 99
33        fi
34        grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35        RETVAL=$?
36        if test "x${RETVAL}" = x0 ; then
37            echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38            exit 99
39       fi
40    }
41    
42    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43    # the package list.
44    expand_pkg_groups() {
45        new_packages=
46        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47        if test -r $PKG_GROUPS ; then
48            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49            cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50            matched=0
51            for i in $PACKAGES ; do
52                line=`grep $i ./p2.tmp`
53                RETVAL=$?
54                if test "x$RETVAL" = x0 ; then
55                    matched=1
56                    replace=`echo $line | awk '{ $1=""; $2=""; print $0 }'`
57                    echo "    replacing \"$i\" with: $replace"
58                    new_packages="$new_packages $replace"
59                else
60                    new_packages="$new_packages $i"
61                fi
62            done
63            PACKAGES=$new_packages
64            rm -f ./p[1,2].tmp
65        else
66            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67        fi
68    }
69    
70  # Guess possible config options for this host  # Guess possible config options for this host
71  find_possible_configs()  {  find_possible_configs()  {
72    
73      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
74      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/'`      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
76      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
77      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
78  #     if test "x$OFLIST" = x ; then  #     if test "x$OFLIST" = x ; then
# Line 181  usage()  { Line 239  usage()  {
239      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
240      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
241      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
242        echo "    -standarddirs NAME | --standarddirs NAME"
243        echo "      -standarddirs=NAME | --standarddirs=NAME"
244      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
245      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
246  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 255  MODS= Line 315  MODS=
315  TOOLSDIR=  TOOLSDIR=
316  SOURCEDIRS=  SOURCEDIRS=
317  INCLUDEDIRS=  INCLUDEDIRS=
318    STANDARDDIRS=
319    
320  PWD=`pwd`  PWD=`pwd`
321  MAKE=make  MAKE=make
# Line 265  MACHINE=`uname -a` Line 326  MACHINE=`uname -a`
326  EXECUTABLE=  EXECUTABLE=
327  EXEHOOK=  EXEHOOK=
328  EXEDIR=  EXEDIR=
329    PACKAGES_CONF=
330    
331  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
332  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
333  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
334    
335  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
336  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
337  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
338  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
339  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
340    
341  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"
342    
343    
344  echo  echo
345  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
346  gm_local="./gm_local"  gm_local="genmake_local"
347    for i in . $MODS ; do
348        if test -r $i/$gm_local ; then
349            source $i/$gm_local
350            break
351        fi
352    done
353  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
354  if test -e $gm_local ; then  if test -e $gm_local ; then
355      echo "using $gm_local"      echo "using $gm_local"
# Line 373  for ac_option ; do Line 441  for ac_option ; do
441          -enable=* | --enable=*)          -enable=* | --enable=*)
442              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
443                    
444            -standarddirs | --standarddirs)
445                ac_prev=STANDARDDIRS ;;
446            -standarddirs=* | --standarddirs=*)
447                STANDARDDIRS=$ac_optarg ;;
448    
449          -noopt | --noopt)          -noopt | --noopt)
450              ac_prev=NOOPT ;;              ac_prev=NOOPT ;;
451          -noopt=* | --noopt=*)          -noopt=* | --noopt=*)
# Line 466  if test "x$OPTFILE" != xNONE ; then Line 539  if test "x$OPTFILE" != xNONE ; then
539              exit 1              exit 1
540          fi          fi
541          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" != xf ; then
542              cp -f $OPTFILE "gm_optfile"              cp -f $OPTFILE "genmake_optfile"
543          fi          fi
544      else      else
545          echo "Error: can't read OPTFILE=\"$OPTFILE\""          echo "Error: can't read OPTFILE=\"$OPTFILE\""
# Line 482  if test "x$FC" = x ; then Line 555  if test "x$FC" = x ; then
555  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
556    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
557    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
558    3) the "./gm_local" file    3) the "./genmake_local" file
559  EOF  EOF
560      exit 1      exit 1
561  fi  fi
# Line 500  if test "x$RETVAL" != x0 ; then Line 573  if test "x$RETVAL" != x0 ; then
573  Error: C pre-processor "$CPP" failed the test case: please specify using:  Error: C pre-processor "$CPP" failed the test case: please specify using:
574    
575    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
576    2) the "./gm_local" file    2) the "./genmake_local" file
577    
578  EOF  EOF
579      exit 1      exit 1
# Line 603  fi Line 676  fi
676  source ./.pd_tmp  source ./.pd_tmp
677  rm -f ./.pd_tmp  rm -f ./.pd_tmp
678    
679    #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
680    #  file should eventually be added so that, for convenience, one can
681    #  specify groups of packages using names like "ocean" and "atmosphere".
682  echo  -n "  checking default package list:  "  echo  -n "  checking default package list:  "
683  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
684        for i in "." $MODS ; do
685            if test -r $i"/packages.conf" ; then
686                    PDEFAULT=$i"/packages.conf"
687                    break
688            fi
689        done
690    fi
691    if test "x${PDEFAULT}" = x ; then
692      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
693  fi  fi
694  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
# Line 626  else Line 710  else
710          for i in $def ; do          for i in $def ; do
711              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
712          done          done
713          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
714            expand_pkg_groups
715            echo "    after group expansion packages are:  $PACKAGES"
716      fi      fi
717  fi  fi
718    
# Line 645  for p in $PACKAGES ; do Line 731  for p in $PACKAGES ; do
731  done  done
732  PACKAGES="$pack"  PACKAGES="$pack"
733  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
734  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
735  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
736  for i in $PACKAGES ; do  for i in $PACKAGES ; do
737      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 761  done Line 847  done
847  # done  # done
848  # echo  # echo
849    
850  echo "  Searching for CPP_OPTIONS.h (macros and flags for configuring the model):"  # Create a list of #define and #undef to enable/disable packages
851  CPP_OPTIONS=  PACKAGES_DOT_H=PACKAGES_CONFIG.h
852  spaths=". $SOURCEDIRS"  cat <<EOF >$PACKAGES_DOT_H".tmp"
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
853  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
854  C  The following defines have been set by GENMAKE, so please do not  C  The following defines have been set by GENMAKE, so please do not
855  C  edit anything below these comments.  In general, you should  C  edit anything below these comments.  In general, you should
856  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
857  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
858    
859    #ifndef PACKAGES_H
860    #define PACKAGES_H
861    
862  C  Packages disabled by genmake:  C  Packages disabled by genmake:
863  EOF  EOF
864  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 814  for n in $names ; do Line 878  for n in $names ; do
878          done          done
879          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
880              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`
881              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
882    #           DEFINES="$DEFINES -U$undef"
883    
884  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
885              case $n in              case $n in
# Line 824  for n in $names ; do Line 889  for n in $names ; do
889                  mom_vecinv)                  mom_vecinv)
890                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"
891                      ;;                      ;;
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
892                  debug)                  debug)
893                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"
894                      ;;                      ;;
# Line 836  for n in $names ; do Line 898  for n in $names ; do
898          fi          fi
899      fi      fi
900  done  done
901  cat <<EOF >>CPP_OPTIONS.h.tmp  cat <<EOF >>$PACKAGES_DOT_H".tmp"
902    
903  C  Packages enabled by genmake:  C  Packages enabled by genmake:
904  EOF  EOF
905  for i in $PACKAGES ; do  for i in $PACKAGES ; do
906      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`
907      echo "#define $def" >> CPP_OPTIONS.h.tmp      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
908    #eh3 DEFINES="$DEFINES -D$def"
909    
910  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
911      case $i in      case $i in
912          aim_v23)          aim_v23)
913              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
914                DEFINES="$DEFINES -DALLOW_AIM"
915                echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
916              ;;              ;;
917      esac      esac
918  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
919    
920  done  done
921  mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  cat <<EOF >>$PACKAGES_DOT_H".tmp"
922    
923    #endif /* PACKAGES_H */
924    EOF
925    
926    if test ! -f $PACKAGES_DOT_H ; then
927        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
928    else
929        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
930        RETVAL=$?
931        if test "x$RETVAL" = x0 ; then
932            rm -f $PACKAGES_DOT_H".tmp"
933        else
934            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
935            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
936        fi
937    fi
938    
939  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
940  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
941  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
942        STANDARDDIRS="eesupp model"
943    fi
944  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
945      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
946      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 877  for d in $STANDARDDIRS ; do Line 960  for d in $STANDARDDIRS ; do
960      fi      fi
961  done  done
962    
963    echo " Searching for CPP_OPTIONS.h in order to warn about the presence"
964    echo " of \"#define ALLOW_PKGNAME\"-type statements:"
965    CPP_OPTIONS=
966    spaths=". $INCLUDEDIRS"
967    for i in $spaths ; do
968        try="$i/CPP_OPTIONS.h"
969        #  echo -n "    trying $try : "
970        if test -f $try -a -r $try ; then
971            echo "    found CPP_OPTIONS=\"$try\""
972            CPP_OPTIONS="$try"
973            break
974        fi
975    done
976    if test "x$CPP_OPTIONS" = x ; then
977        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
978        exit 1
979    fi
980    # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
981    names=`ls -1 "$ROOTDIR/pkg"`
982    for n in $names ; do
983        test_for_package_in_cpp_options $CPP_OPTIONS $n
984    done
985    
986    
987  echo  echo
988  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
989  echo "  setting INCLUDES"  echo "  setting INCLUDES"
990  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
991      if test -d $i ; then      if ! test -d $i ; then
992          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
993      else  #   else
994          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
995      fi      fi
996  done  done
# Line 1064  clean: Line 1170  clean:
1170  Clean:  Clean:
1171          @make clean          @make clean
1172          @make cleanlinks          @make cleanlinks
1173          -rm -f Makefile.bak          -rm -f Makefile.bak genmake_state genmake_optfile make.log
1174  CLEAN:  CLEAN:
1175          @make Clean          @make Clean
1176          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1177          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1178          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1179          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1180    
1181  makefile:  makefile:
1182          ${0} $@          ${0} $@
# Line 1134  printf "\n===  Done  ===\n" Line 1240  printf "\n===  Done  ===\n"
1240    
1241  #  Write the "state" for future records  #  Write the "state" for future records
1242  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1243      echo -n "" > gm_state      echo -n "" > genmake_state
1244      for i in $gm_state ; do      for i in $gm_state ; do
1245          t1="t2=\$$i"          t1="t2=\$$i"
1246          eval $t1          eval $t1
1247          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1248      done      done
1249  fi  fi

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.11.2.10

  ViewVC Help
Powered by ViewVC 1.1.22